package com.hai.dao;

import com.hai.entity.HighCoupon;
import com.hai.entity.HighCouponExample.Criteria;
import com.hai.entity.HighCouponExample.Criterion;
import com.hai.entity.HighCouponExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighCouponSqlProvider {

    public String countByExample(HighCouponExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_coupon");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighCouponExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_coupon");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighCoupon record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_coupon");
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantId() != null) {
            sql.VALUES("merchant_id", "#{merchantId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponKey() != null) {
            sql.VALUES("coupon_key", "#{couponKey,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponName() != null) {
            sql.VALUES("coupon_name", "#{couponName,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponPrice() != null) {
            sql.VALUES("coupon_price", "#{couponPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getCouponImg() != null) {
            sql.VALUES("coupon_img", "#{couponImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponCarouselImg() != null) {
            sql.VALUES("coupon_carousel_img", "#{couponCarouselImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponDesc() != null) {
            sql.VALUES("coupon_desc", "#{couponDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponType() != null) {
            sql.VALUES("coupon_type", "#{couponType,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.VALUES("sales_end_time", "#{salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRecycleDay() != null) {
            sql.VALUES("recycle_day", "#{recycleDay,jdbcType=INTEGER}");
        }
        
        if (record.getLimitNumber() != null) {
            sql.VALUES("limit_number", "#{limitNumber,jdbcType=INTEGER}");
        }
        
        if (record.getSalesPrice() != null) {
            sql.VALUES("sales_price", "#{salesPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getDiscountPrice() != null) {
            sql.VALUES("discount_price", "#{discountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesCount() != null) {
            sql.VALUES("sales_count", "#{salesCount,jdbcType=INTEGER}");
        }
        
        if (record.getIsPresent() != null) {
            sql.VALUES("is_present", "#{isPresent,jdbcType=BIT}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.VALUES("operator_id", "#{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.VALUES("operator_name", "#{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.VALUES("pay_type", "#{payType,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getDisplayArea() != null) {
            sql.VALUES("display_area", "#{displayArea,jdbcType=INTEGER}");
        }
        
        if (record.getCouponSource() != null) {
            sql.VALUES("coupon_source", "#{couponSource,jdbcType=INTEGER}");
        }
        
        if (record.getDistributor() != null) {
            sql.VALUES("distributor", "#{distributor,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsTypeId() != null) {
            sql.VALUES("goods_type_id", "#{goodsTypeId,jdbcType=INTEGER}");
        }
        
        if (record.getBrandId() != null) {
            sql.VALUES("brand_id", "#{brandId,jdbcType=INTEGER}");
        }
        
        if (record.getReserveStatus() != null) {
            sql.VALUES("reserve_status", "#{reserveStatus,jdbcType=BIT}");
        }
        
        if (record.getBuyPoints() != null) {
            sql.VALUES("buy_points", "#{buyPoints,jdbcType=BIT}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighCouponExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("company_id");
        sql.SELECT("merchant_id");
        sql.SELECT("coupon_key");
        sql.SELECT("coupon_name");
        sql.SELECT("coupon_price");
        sql.SELECT("coupon_img");
        sql.SELECT("coupon_carousel_img");
        sql.SELECT("coupon_desc");
        sql.SELECT("coupon_type");
        sql.SELECT("sales_end_time");
        sql.SELECT("recycle_day");
        sql.SELECT("limit_number");
        sql.SELECT("sales_price");
        sql.SELECT("discount_price");
        sql.SELECT("sales_count");
        sql.SELECT("is_present");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("operator_id");
        sql.SELECT("operator_name");
        sql.SELECT("pay_type");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("`status`");
        sql.SELECT("display_area");
        sql.SELECT("coupon_source");
        sql.SELECT("distributor");
        sql.SELECT("goods_type_id");
        sql.SELECT("brand_id");
        sql.SELECT("reserve_status");
        sql.SELECT("buy_points");
        sql.FROM("high_coupon");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighCoupon record = (HighCoupon) parameter.get("record");
        HighCouponExample example = (HighCouponExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_coupon");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantId() != null) {
            sql.SET("merchant_id = #{record.merchantId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponKey() != null) {
            sql.SET("coupon_key = #{record.couponKey,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponName() != null) {
            sql.SET("coupon_name = #{record.couponName,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponPrice() != null) {
            sql.SET("coupon_price = #{record.couponPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getCouponImg() != null) {
            sql.SET("coupon_img = #{record.couponImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponCarouselImg() != null) {
            sql.SET("coupon_carousel_img = #{record.couponCarouselImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponDesc() != null) {
            sql.SET("coupon_desc = #{record.couponDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponType() != null) {
            sql.SET("coupon_type = #{record.couponType,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.SET("sales_end_time = #{record.salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRecycleDay() != null) {
            sql.SET("recycle_day = #{record.recycleDay,jdbcType=INTEGER}");
        }
        
        if (record.getLimitNumber() != null) {
            sql.SET("limit_number = #{record.limitNumber,jdbcType=INTEGER}");
        }
        
        if (record.getSalesPrice() != null) {
            sql.SET("sales_price = #{record.salesPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getDiscountPrice() != null) {
            sql.SET("discount_price = #{record.discountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesCount() != null) {
            sql.SET("sales_count = #{record.salesCount,jdbcType=INTEGER}");
        }
        
        if (record.getIsPresent() != null) {
            sql.SET("is_present = #{record.isPresent,jdbcType=BIT}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getDisplayArea() != null) {
            sql.SET("display_area = #{record.displayArea,jdbcType=INTEGER}");
        }
        
        if (record.getCouponSource() != null) {
            sql.SET("coupon_source = #{record.couponSource,jdbcType=INTEGER}");
        }
        
        if (record.getDistributor() != null) {
            sql.SET("distributor = #{record.distributor,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsTypeId() != null) {
            sql.SET("goods_type_id = #{record.goodsTypeId,jdbcType=INTEGER}");
        }
        
        if (record.getBrandId() != null) {
            sql.SET("brand_id = #{record.brandId,jdbcType=INTEGER}");
        }
        
        if (record.getReserveStatus() != null) {
            sql.SET("reserve_status = #{record.reserveStatus,jdbcType=BIT}");
        }
        
        if (record.getBuyPoints() != null) {
            sql.SET("buy_points = #{record.buyPoints,jdbcType=BIT}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_coupon");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("merchant_id = #{record.merchantId,jdbcType=BIGINT}");
        sql.SET("coupon_key = #{record.couponKey,jdbcType=VARCHAR}");
        sql.SET("coupon_name = #{record.couponName,jdbcType=VARCHAR}");
        sql.SET("coupon_price = #{record.couponPrice,jdbcType=DECIMAL}");
        sql.SET("coupon_img = #{record.couponImg,jdbcType=VARCHAR}");
        sql.SET("coupon_carousel_img = #{record.couponCarouselImg,jdbcType=VARCHAR}");
        sql.SET("coupon_desc = #{record.couponDesc,jdbcType=VARCHAR}");
        sql.SET("coupon_type = #{record.couponType,jdbcType=INTEGER}");
        sql.SET("sales_end_time = #{record.salesEndTime,jdbcType=TIMESTAMP}");
        sql.SET("recycle_day = #{record.recycleDay,jdbcType=INTEGER}");
        sql.SET("limit_number = #{record.limitNumber,jdbcType=INTEGER}");
        sql.SET("sales_price = #{record.salesPrice,jdbcType=DECIMAL}");
        sql.SET("discount_price = #{record.discountPrice,jdbcType=DECIMAL}");
        sql.SET("sales_count = #{record.salesCount,jdbcType=INTEGER}");
        sql.SET("is_present = #{record.isPresent,jdbcType=BIT}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        sql.SET("pay_type = #{record.payType,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("display_area = #{record.displayArea,jdbcType=INTEGER}");
        sql.SET("coupon_source = #{record.couponSource,jdbcType=INTEGER}");
        sql.SET("distributor = #{record.distributor,jdbcType=INTEGER}");
        sql.SET("goods_type_id = #{record.goodsTypeId,jdbcType=INTEGER}");
        sql.SET("brand_id = #{record.brandId,jdbcType=INTEGER}");
        sql.SET("reserve_status = #{record.reserveStatus,jdbcType=BIT}");
        sql.SET("buy_points = #{record.buyPoints,jdbcType=BIT}");
        
        HighCouponExample example = (HighCouponExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighCoupon record) {
        SQL sql = new SQL();
        sql.UPDATE("high_coupon");
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getMerchantId() != null) {
            sql.SET("merchant_id = #{merchantId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponKey() != null) {
            sql.SET("coupon_key = #{couponKey,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponName() != null) {
            sql.SET("coupon_name = #{couponName,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponPrice() != null) {
            sql.SET("coupon_price = #{couponPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getCouponImg() != null) {
            sql.SET("coupon_img = #{couponImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponCarouselImg() != null) {
            sql.SET("coupon_carousel_img = #{couponCarouselImg,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponDesc() != null) {
            sql.SET("coupon_desc = #{couponDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponType() != null) {
            sql.SET("coupon_type = #{couponType,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.SET("sales_end_time = #{salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRecycleDay() != null) {
            sql.SET("recycle_day = #{recycleDay,jdbcType=INTEGER}");
        }
        
        if (record.getLimitNumber() != null) {
            sql.SET("limit_number = #{limitNumber,jdbcType=INTEGER}");
        }
        
        if (record.getSalesPrice() != null) {
            sql.SET("sales_price = #{salesPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getDiscountPrice() != null) {
            sql.SET("discount_price = #{discountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesCount() != null) {
            sql.SET("sales_count = #{salesCount,jdbcType=INTEGER}");
        }
        
        if (record.getIsPresent() != null) {
            sql.SET("is_present = #{isPresent,jdbcType=BIT}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getPayType() != null) {
            sql.SET("pay_type = #{payType,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getDisplayArea() != null) {
            sql.SET("display_area = #{displayArea,jdbcType=INTEGER}");
        }
        
        if (record.getCouponSource() != null) {
            sql.SET("coupon_source = #{couponSource,jdbcType=INTEGER}");
        }
        
        if (record.getDistributor() != null) {
            sql.SET("distributor = #{distributor,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsTypeId() != null) {
            sql.SET("goods_type_id = #{goodsTypeId,jdbcType=INTEGER}");
        }
        
        if (record.getBrandId() != null) {
            sql.SET("brand_id = #{brandId,jdbcType=INTEGER}");
        }
        
        if (record.getReserveStatus() != null) {
            sql.SET("reserve_status = #{reserveStatus,jdbcType=BIT}");
        }
        
        if (record.getBuyPoints() != null) {
            sql.SET("buy_points = #{buyPoints,jdbcType=BIT}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighCouponExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}